Status: Closed Priority: Should have
Author: Fabrizio Branca Category: TypoScript
Created: 2011-07-11 Assigned To: Fabrizio Branca
Updated: 2013-06-01 Due date:
PHP Version: 5.3
Complexity:
Sprint Focus:
Subject: Add hashing algorithms to stdWrap
Description

Currently it is not possible to get an md5 hash for a value in stdWrap. By adding some lines we could have md5 generation e.g.
enabling you to get a gravatar image without using a userfunc:

page.10 = TEXT
page.10 {
  value = mail@domain.com
  md5 = 1
  wrap = <img src="http://www.gravatar.com/avatar/|" />
}

Related issues:
related to Core - Feature # 28230: Add support for PBKDF2 to hashing Accepted 2011-07-15
precedes Core - Bug # 28120: stdWrap.hash: Return nothing for non-existing al... Closed 2011-07-12

Associated revisions
Revision d2e68695 - 2011-07-12 09:36 - Fabrizio Branca

[FEATURE] Add hashing algorithms to stdWrap

Enable hashing the content through stdWrap using different hashing algorithms

Change-Id: I0673f33a1ca7bcb5784e5ab9f0def8db5ff7ea4b
Resolves: #28095
Releases: 4.6
Reviewed-on: http://review.typo3.org/3257
Reviewed-by: Stefan Neufeind
Tested-by: Stefan Neufeind
Reviewed-by: Xavier Perseguers
Tested-by: Xavier Perseguers

History
#1 - 2011-07-11 20:12 - Xavier Perseguers

I don't like the idea of adding md5 alone. Better would be to support sha1 too and possibly lots of other hashing algorithms.

Have a look at http://ch.php.net/manual/en/function.hash-algos.php, PHP 5.3 has a lot of supported hashing algorithms. For me supporting md5, sha1,
sha256 seems a must have if we implement this feature.

What about:
page.10 = TEXT
page.10 {
    value = mail@domain.com
    hash = md5
    wrap = <img src="http://www.gravatar.com/avatar/|" />
}

Just add stdWrap on hash (to let us do whatever we want) and then the implementation is basically this one:

if (function_exists('hash') && in_array($algo, hash_algos())) {
    $hash = hash($algo, $plain);
// elseif parts even optional I guess
} elseif ($algo === 'md5') {
    $hash = md5($plain);
} elseif ($algo === 'sha1') {
    $hash = sha1($plain)
} else {
    $hash = $plain;
}
return $hash;

#2 - 2011-07-11 20:48 - Fabrizio Branca

That looks good. I'm still struggling with setting up git/gerrit to push this patch. I'll create an updated patch for that and push that to Gerrit, if you don't
mind...

#3 - 2011-07-11 21:03 - Mr. Hudson

Patch set 1 of change I0673f33a1ca7bcb5784e5ab9f0def8db5ff7ea4b has been pushed to the review server.
It is available at http://review.typo3.org/3257

#4 - 2011-07-11 21:06 - Mr. Hudson

Patch set 1 of change I3967541526149d1b40b2a676307a60a39670405a has been pushed to the review server.
It is available at http://review.typo3.org/3258

#5 - 2011-07-11 21:10 - Fabrizio Branca

I tried to update my first path for a whitespace fix, but it seems that I did not create a new patchset but a complete new patch by removing the
Change-Id line. Sorry for that...

#6 - 2011-07-11 21:14 - Xavier Perseguers

Just abandone one of them, possibly the one without my review...
and possibly update commit message to describe what it does without saying that it was not possible before...

#7 - 2011-07-11 21:16 - Xavier Perseguers

Do not forget either the pending documentation in wiki for stdWrap once it is merged

#8 - 2011-07-11 21:24 - Mr. Hudson

Patch set 2 of change I0673f33a1ca7bcb5784e5ab9f0def8db5ff7ea4b has been pushed to the review server.
It is available at http://review.typo3.org/3257

#9 - 2011-07-11 21:42 - Mr. Hudson

Patch set 3 of change I0673f33a1ca7bcb5784e5ab9f0def8db5ff7ea4b has been pushed to the review server.
It is available at http://review.typo3.org/3257

#10 - 2011-07-11 22:35 - Mr. Hudson

Patch set 4 of change I0673f33a1ca7bcb5784e5ab9f0def8db5ff7ea4b has been pushed to the review server.
It is available at http://review.typo3.org/3257

#11 - 2011-07-11 22:46 - Xavier Perseguers
- Subject changed from Add md5 to stdWrap to Add hashing algorithms to stdWrap
- PHP Version set to 5.3

#12 - 2011-07-11 23:01 - Xavier Perseguers
- Category changed from Content Rendering to TypoScript

#13 - 2011-07-11 23:05 - Xavier Perseguers
- Status changed from New to Under Review

#14 - 2011-07-12 08:57 - Mr. Hudson

Patch set 5 of change I0673f33a1ca7bcb5784e5ab9f0def8db5ff7ea4b has been pushed to the review server.
It is available at http://review.typo3.org/3257

#15 - 2011-07-12 09:36 - Xavier Perseguers
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Change has been successfully cherry-picked as d2e68695fd4e55d888544d7b7b8b699544ab16ed.

#16 - 2012-03-07 13:32 - Xavier Perseguers
- Status changed from Resolved to Closed
#17 - 2013-06-01 14:43 - Ernesto Baschny
- Target version deleted (1281)
